//http://imageshack.us/a/img46/9950/crosshairp.png

using System;
using System.Windows.Forms;
using System.IO;
using GTA;
using GTA.Native;

public class HitIndicator : Script
{
   Texture crosshairTexture;
   const float TEXTURE_WIDTH = 36, TEXTURE_HEIGHT = 36, TEXTURE_ROTATION = 40;
   const string TEXTURE_PATH = @"C:\Program Files (x86)\Rockstar Games/Grand Theft Auto IV\Scripts\Hit Indicator\hit X.png";//fix the file path to wherever u save your crosshair image, i gave u one at link above or find your own;)

   bool cursorOn = true;
   bool drawCursor = false;

   public HitIndicator()
   {
       crosshairTexture = new Texture(File.ReadAllBytes(TEXTURE_PATH));
       this.BindKey(Keys.F11, ToggleCursor);
       this.PerFrameDrawing += this.HitCursor_PerFrameDrawing;
       this.Tick += HitIndicator_Tick;
   }
   private void HitIndicator_Tick(object sender, EventArgs e)
   {
       drawCursor = false;
       if (Function.Call<bool>("HAS_PLAYER_DAMAGED_AT_LEAST_ONE_PED", Player.Index))
       {
           Function.Call("CLEAR_PLAYER_HAS_DAMAGED_AT_LEAST_ONE_PED", Player.Index);
           foreach (Ped ped in World.GetAllPeds())
           {
               Function.Call("CLEAR_CHAR_LAST_DAMAGE_ENTITY", ped);
           }
           drawCursor = true;
       }
       if (Player.Character.Weapons.CurrentType == Weapon.Unarmed || Player.Character.Weapons.CurrentType == Weapon.Melee_BaseballBat || Player.Character.Weapons.CurrentType == Weapon.Melee_Knife)
       {
           drawCursor = false;
       }

       if (Game.LocalPlayer.Character.isInVehicle())
       {
           if (!Game.LocalPlayer.Character.isShooting)
           {
               drawCursor = false;
           }
       }
   }
   private void HitCursor_PerFrameDrawing(object sender, GraphicsEventArgs e)
   {
       if (drawCursor)
       {
           e.Graphics.DrawSprite(crosshairTexture, Game.Resolution.Width / 2, Game.Resolution.Height / 2, TEXTURE_WIDTH, TEXTURE_HEIGHT, TEXTURE_ROTATION);
       }
   }

   private void ToggleCursor()
   {
       cursorOn = !cursorOn;

       if (cursorOn)
       {
           Tick += HitIndicator_Tick;
           PerFrameDrawing += HitCursor_PerFrameDrawing;
           Game.DisplayText("Hit Cursor Activated");
       }
       else
       {
           Tick -= HitIndicator_Tick;
           PerFrameDrawing -= HitCursor_PerFrameDrawing;
           Game.DisplayText("Hit Cursor Deactivated");
       }
   }
}